---
title: User Schemas
---

[Skip to content](#_top)

[API Reference](https://developers.cloudflare.com/api/python)

[API Gateway](https://developers.cloudflare.com/api/python/resources/api_gateway)

Copy Markdown

Open in **Claude**Open in **ChatGPT**Open in **Cursor**

---

**Copy Markdown****View as Markdown**

# User Schemas

##### [Retrieve information about all schemas on a zone](https://developers.cloudflare.com/api/python/resources/api_gateway/subresources/user_schemas/methods/list)

Deprecated

api\_gateway.user\_schemas.list(UserSchemaListParams\*\*kwargs) -> SyncV4PagePaginationArray\[[OldPublicSchema](<https://developers.cloudflare.com/api/python/resources/api_gateway#(resource)%20api_gateway.user_schemas%20%3E%20(model)%20old_public_schema%20%3E%20(schema)>)]

GET/zones/{zone\_id}/api\_gateway/user\_schemas

##### [Retrieve information about a specific schema on a zone](https://developers.cloudflare.com/api/python/resources/api_gateway/subresources/user_schemas/methods/get)

Deprecated

api\_gateway.user\_schemas.get(strschema\_id, UserSchemaGetParams\*\*kwargs) -> [OldPublicSchema](<https://developers.cloudflare.com/api/python/resources/api_gateway#(resource)%20api_gateway.user_schemas%20%3E%20(model)%20old_public_schema%20%3E%20(schema)>)

GET/zones/{zone\_id}/api\_gateway/user\_schemas/{schema\_id}

##### [Upload a legacy schema](https://developers.cloudflare.com/api/python/resources/api_gateway/subresources/user_schemas/methods/create)

Deprecated

api\_gateway.user\_schemas.create(UserSchemaCreateParams\*\*kwargs) -> [UserSchemaCreateResponse](<https://developers.cloudflare.com/api/python/resources/api_gateway#(resource)%20api_gateway.user_schemas%20%3E%20(model)%20user_schema_create_response%20%3E%20(schema)>)

POST/zones/{zone\_id}/api\_gateway/user\_schemas

##### [Enable validation for a schema](https://developers.cloudflare.com/api/python/resources/api_gateway/subresources/user_schemas/methods/edit)

Deprecated

api\_gateway.user\_schemas.edit(strschema\_id, UserSchemaEditParams\*\*kwargs) -> [OldPublicSchema](<https://developers.cloudflare.com/api/python/resources/api_gateway#(resource)%20api_gateway.user_schemas%20%3E%20(model)%20old_public_schema%20%3E%20(schema)>)

PATCH/zones/{zone\_id}/api\_gateway/user\_schemas/{schema\_id}

##### [Delete a schema](https://developers.cloudflare.com/api/python/resources/api_gateway/subresources/user_schemas/methods/delete)

Deprecated

api\_gateway.user\_schemas.delete(strschema\_id, UserSchemaDeleteParams\*\*kwargs) -> [UserSchemaDeleteResponse](<https://developers.cloudflare.com/api/python/resources/api_gateway#(resource)%20api_gateway.user_schemas%20%3E%20(model)%20user_schema_delete_response%20%3E%20(schema)>)

DELETE/zones/{zone\_id}/api\_gateway/user\_schemas/{schema\_id}

##### ModelsExpand Collapse

<details>

<summary>

List\[MessageItem]

</summary>

code: int

minimum1000

<a href="#(resource)%20api_gateway.user_schemas%20%3E%20(model)%20message%20%3E%20(schema)%20%3E%20(items)%20%3E%20(property)%20code">Link to this property</a>

message: str

<a href="#(resource)%20api_gateway.user_schemas%20%3E%20(model)%20message%20%3E%20(schema)%20%3E%20(items)%20%3E%20(property)%20message">Link to this property</a>

documentation\_url: Optional\[str]

<a href="#(resource)%20api_gateway.user_schemas%20%3E%20(model)%20message%20%3E%20(schema)%20%3E%20(items)%20%3E%20(property)%20documentation_url">Link to this property</a>

<details>

<summary>

source: Optional\[MessageItemSource]

</summary>

pointer: Optional\[str]

<a href="#(resource)%20api_gateway.user_schemas%20%3E%20(model)%20message%20%3E%20(schema)%20%3E%20(items)%20%3E%20(property)%20source%20%3E%20(property)%20pointer">Link to this property</a>

</details>

<a href="#(resource)%20api_gateway.user_schemas%20%3E%20(model)%20message%20%3E%20(schema)%20%3E%20(items)%20%3E%20(property)%20source">Link to this property</a>

</details>

[Link to this property](<#(resource)%20api_gateway.user_schemas%20%3E%20(model)%20message%20%3E%20(schema)>)

<details>

<summary>

class OldPublicSchema: …

</summary>

created\_at: datetime

formatdate-time

<a href="#(resource)%20api_gateway.user_schemas%20%3E%20(model)%20old_public_schema%20%3E%20(schema)%20%3E%20(property)%20created_at">Link to this property</a>

kind: Literal\["openapi\_v3"]

Kind of schema

<a href="#(resource)%20api_gateway.user_schemas%20%3E%20(model)%20old_public_schema%20%3E%20(schema)%20%3E%20(property)%20kind">Link to this property</a>

name: str

Name of the schema

<a href="#(resource)%20api_gateway.user_schemas%20%3E%20(model)%20old_public_schema%20%3E%20(schema)%20%3E%20(property)%20name">Link to this property</a>

schema\_id: str

UUID.

maxLength36

minLength36

<a href="#(resource)%20api_gateway.user_schemas%20%3E%20(model)%20old_public_schema%20%3E%20(schema)%20%3E%20(property)%20schema_id">Link to this property</a>

source: Optional\[str]

Source of the schema

<a href="#(resource)%20api_gateway.user_schemas%20%3E%20(model)%20old_public_schema%20%3E%20(schema)%20%3E%20(property)%20source">Link to this property</a>

validation\_enabled: Optional\[bool]

Flag whether schema is enabled for validation.

<a href="#(resource)%20api_gateway.user_schemas%20%3E%20(model)%20old_public_schema%20%3E%20(schema)%20%3E%20(property)%20validation_enabled">Link to this property</a>

</details>

[Link to this property](<#(resource)%20api_gateway.user_schemas%20%3E%20(model)%20old_public_schema%20%3E%20(schema)>)

<details>

<summary>

class UserSchemaCreateResponse: …

</summary>

schema: <a href="https://developers.cloudflare.com/api/python/resources/api_gateway#(resource)%20api_gateway.user_schemas%20%3E%20(model)%20old_public_schema%20%3E%20(schema)">OldPublicSchema</a>

<a href="#(resource)%20api_gateway.user_schemas%20%3E%20(model)%20user_schema_create_response%20%3E%20(schema)%20%3E%20(property)%20schema">Link to this property</a>

<details>

<summary>

upload\_details: Optional\[UploadDetails]

</summary>

<details>

<summary>

warnings: Optional\[List\[UploadDetailsWarning]]

Diagnostic warning events that occurred during processing. These events are non-critical errors found within the schema.

</summary>

code: int

Code that identifies the event that occurred.

<a href="#(resource)%20api_gateway.user_schemas%20%3E%20(model)%20user_schema_create_response%20%3E%20(schema)%20%3E%20(property)%20upload_details%20%3E%20(property)%20warnings%20%3E%20(items)%20%3E%20(property)%20code">Link to this property</a>

locations: Optional\[List\[str]]

JSONPath location(s) in the schema where these events were encountered. See <a href="https://goessner.net/articles/JsonPath/">https://goessner.net/articles/JsonPath/</a> for JSONPath specification.

<a href="#(resource)%20api_gateway.user_schemas%20%3E%20(model)%20user_schema_create_response%20%3E%20(schema)%20%3E%20(property)%20upload_details%20%3E%20(property)%20warnings%20%3E%20(items)%20%3E%20(property)%20locations">Link to this property</a>

message: Optional\[str]

Diagnostic message that describes the event.

<a href="#(resource)%20api_gateway.user_schemas%20%3E%20(model)%20user_schema_create_response%20%3E%20(schema)%20%3E%20(property)%20upload_details%20%3E%20(property)%20warnings%20%3E%20(items)%20%3E%20(property)%20message">Link to this property</a>

</details>

<a href="#(resource)%20api_gateway.user_schemas%20%3E%20(model)%20user_schema_create_response%20%3E%20(schema)%20%3E%20(property)%20upload_details%20%3E%20(property)%20warnings">Link to this property</a>

</details>

<a href="#(resource)%20api_gateway.user_schemas%20%3E%20(model)%20user_schema_create_response%20%3E%20(schema)%20%3E%20(property)%20upload_details">Link to this property</a>

</details>

[Link to this property](<#(resource)%20api_gateway.user_schemas%20%3E%20(model)%20user_schema_create_response%20%3E%20(schema)>)

<details>

<summary>

class UserSchemaDeleteResponse: …

</summary>

errors: <a href="https://developers.cloudflare.com/api/python/resources/api_gateway#(resource)%20api_gateway.user_schemas%20%3E%20(model)%20message%20%3E%20(schema)">Message</a>

<a href="#(resource)%20api_gateway.user_schemas%20%3E%20(model)%20user_schema_delete_response%20%3E%20(schema)%20%3E%20(property)%20errors">Link to this property</a>

messages: <a href="https://developers.cloudflare.com/api/python/resources/api_gateway#(resource)%20api_gateway.user_schemas%20%3E%20(model)%20message%20%3E%20(schema)">Message</a>

<a href="#(resource)%20api_gateway.user_schemas%20%3E%20(model)%20user_schema_delete_response%20%3E%20(schema)%20%3E%20(property)%20messages">Link to this property</a>

success: Literal\[true]

Whether the API call was successful.

<a href="#(resource)%20api_gateway.user_schemas%20%3E%20(model)%20user_schema_delete_response%20%3E%20(schema)%20%3E%20(property)%20success">Link to this property</a>

</details>

[Link to this property](<#(resource)%20api_gateway.user_schemas%20%3E%20(model)%20user_schema_delete_response%20%3E%20(schema)>)

#### User SchemasOperations

##### [Retrieve all operations from a schema](https://developers.cloudflare.com/api/python/resources/api_gateway/subresources/user_schemas/subresources/operations/methods/list)

Deprecated

api\_gateway.user\_schemas.operations.list(strschema\_id, OperationListParams\*\*kwargs) -> SyncV4PagePaginationArray\[[OperationListResponse](<https://developers.cloudflare.com/api/python/resources/api_gateway#(resource)%20api_gateway.user_schemas.operations%20%3E%20(model)%20operation_list_response%20%3E%20(schema)>)]

GET/zones/{zone\_id}/api\_gateway/user\_schemas/{schema\_id}/operations

##### ModelsExpand Collapse

<details>

<summary>

<a href="https://developers.cloudflare.com/api/python/resources/api_gateway#(resource)%20api_gateway.user_schemas.operations%20%3E%20(model)%20operation_list_response%20%3E%20(schema)">OperationListResponse</a>

</summary>

One of the following:

<details>

<summary>

class APIShieldOperation: …

</summary>

endpoint: str

The endpoint which can contain path parameter templates in curly braces, each will be replaced from left to right with {varN}, starting with {var1}, during insertion. This will further be Cloudflare-normalized upon insertion. See: <a href="https://developers.cloudflare.com/rules/normalization/how-it-works/">https://developers.cloudflare.com/rules/normalization/how-it-works/</a>.

formaturi-template

maxLength4096

<a href="#(resource)%20api_gateway.user_schemas.operations%20%3E%20(model)%20operation_list_response%20%3E%20(schema)%20%3E%20(variant)%200%20%3E%20(property)%20endpoint">Link to this property</a>

host: str

RFC3986-compliant host.

formathostname

maxLength255

<a href="#(resource)%20api_gateway.user_schemas.operations%20%3E%20(model)%20operation_list_response%20%3E%20(schema)%20%3E%20(variant)%200%20%3E%20(property)%20host">Link to this property</a>

last\_updated: datetime

formatdate-time

<a href="#(resource)%20api_gateway.user_schemas.operations%20%3E%20(model)%20operation_list_response%20%3E%20(schema)%20%3E%20(variant)%200%20%3E%20(property)%20last_updated">Link to this property</a>

<details>

<summary>

method: Literal\["GET", "POST", "HEAD", 6 more]

The HTTP method used to access the endpoint.

</summary>

One of the following:

"GET"

<a href="#(resource)%20api_gateway.user_schemas.operations%20%3E%20(model)%20operation_list_response%20%3E%20(schema)%20%3E%20(variant)%200%20%3E%20(property)%20method%20%3E%20(member)%200">Link to this property</a>

"POST"

<a href="#(resource)%20api_gateway.user_schemas.operations%20%3E%20(model)%20operation_list_response%20%3E%20(schema)%20%3E%20(variant)%200%20%3E%20(property)%20method%20%3E%20(member)%201">Link to this property</a>

"HEAD"

<a href="#(resource)%20api_gateway.user_schemas.operations%20%3E%20(model)%20operation_list_response%20%3E%20(schema)%20%3E%20(variant)%200%20%3E%20(property)%20method%20%3E%20(member)%202">Link to this property</a>

"OPTIONS"

<a href="#(resource)%20api_gateway.user_schemas.operations%20%3E%20(model)%20operation_list_response%20%3E%20(schema)%20%3E%20(variant)%200%20%3E%20(property)%20method%20%3E%20(member)%203">Link to this property</a>

"PUT"

<a href="#(resource)%20api_gateway.user_schemas.operations%20%3E%20(model)%20operation_list_response%20%3E%20(schema)%20%3E%20(variant)%200%20%3E%20(property)%20method%20%3E%20(member)%204">Link to this property</a>

"DELETE"

<a href="#(resource)%20api_gateway.user_schemas.operations%20%3E%20(model)%20operation_list_response%20%3E%20(schema)%20%3E%20(variant)%200%20%3E%20(property)%20method%20%3E%20(member)%205">Link to this property</a>

"CONNECT"

<a href="#(resource)%20api_gateway.user_schemas.operations%20%3E%20(model)%20operation_list_response%20%3E%20(schema)%20%3E%20(variant)%200%20%3E%20(property)%20method%20%3E%20(member)%206">Link to this property</a>

"PATCH"

<a href="#(resource)%20api_gateway.user_schemas.operations%20%3E%20(model)%20operation_list_response%20%3E%20(schema)%20%3E%20(variant)%200%20%3E%20(property)%20method%20%3E%20(member)%207">Link to this property</a>

"TRACE"

<a href="#(resource)%20api_gateway.user_schemas.operations%20%3E%20(model)%20operation_list_response%20%3E%20(schema)%20%3E%20(variant)%200%20%3E%20(property)%20method%20%3E%20(member)%208">Link to this property</a>

</details>

<a href="#(resource)%20api_gateway.user_schemas.operations%20%3E%20(model)%20operation_list_response%20%3E%20(schema)%20%3E%20(variant)%200%20%3E%20(property)%20method">Link to this property</a>

operation\_id: str

UUID.

maxLength36

minLength36

<a href="#(resource)%20api_gateway.user_schemas.operations%20%3E%20(model)%20operation_list_response%20%3E%20(schema)%20%3E%20(variant)%200%20%3E%20(property)%20operation_id">Link to this property</a>

<details>

<summary>

features: Optional\[APIShieldOperationFeatures]

</summary>

One of the following:

<details>

<summary>

class APIShieldOperationFeaturesAPIShieldOperationFeatureThresholds: …

</summary>

<details>

<summary>

thresholds: Optional\[APIShieldOperationFeaturesAPIShieldOperationFeatureThresholdsThresholds]

</summary>

auth\_id\_tokens: Optional\[int]

The total number of auth-ids seen across this calculation.

<a href="#(resource)%20api_gateway.user_schemas.operations%20%3E%20(model)%20operation_list_response%20%3E%20(schema)%20%3E%20(variant)%200%20%3E%20(property)%20features%20%3E%20(variant)%200%20%3E%20(property)%20thresholds%20%3E%20(property)%20auth_id_tokens">Link to this property</a>

data\_points: Optional\[int]

The number of data points used for the threshold suggestion calculation.

<a href="#(resource)%20api_gateway.user_schemas.operations%20%3E%20(model)%20operation_list_response%20%3E%20(schema)%20%3E%20(variant)%200%20%3E%20(property)%20features%20%3E%20(variant)%200%20%3E%20(property)%20thresholds%20%3E%20(property)%20data_points">Link to this property</a>

last\_updated: Optional\[datetime]

formatdate-time

<a href="#(resource)%20api_gateway.user_schemas.operations%20%3E%20(model)%20operation_list_response%20%3E%20(schema)%20%3E%20(variant)%200%20%3E%20(property)%20features%20%3E%20(variant)%200%20%3E%20(property)%20thresholds%20%3E%20(property)%20last_updated">Link to this property</a>

p50: Optional\[int]

The p50 quantile of requests (in period\_seconds).

<a href="#(resource)%20api_gateway.user_schemas.operations%20%3E%20(model)%20operation_list_response%20%3E%20(schema)%20%3E%20(variant)%200%20%3E%20(property)%20features%20%3E%20(variant)%200%20%3E%20(property)%20thresholds%20%3E%20(property)%20p50">Link to this property</a>

p90: Optional\[int]

The p90 quantile of requests (in period\_seconds).

<a href="#(resource)%20api_gateway.user_schemas.operations%20%3E%20(model)%20operation_list_response%20%3E%20(schema)%20%3E%20(variant)%200%20%3E%20(property)%20features%20%3E%20(variant)%200%20%3E%20(property)%20thresholds%20%3E%20(property)%20p90">Link to this property</a>

p99: Optional\[int]

The p99 quantile of requests (in period\_seconds).

<a href="#(resource)%20api_gateway.user_schemas.operations%20%3E%20(model)%20operation_list_response%20%3E%20(schema)%20%3E%20(variant)%200%20%3E%20(property)%20features%20%3E%20(variant)%200%20%3E%20(property)%20thresholds%20%3E%20(property)%20p99">Link to this property</a>

period\_seconds: Optional\[int]

The period over which this threshold is suggested.

<a href="#(resource)%20api_gateway.user_schemas.operations%20%3E%20(model)%20operation_list_response%20%3E%20(schema)%20%3E%20(variant)%200%20%3E%20(property)%20features%20%3E%20(variant)%200%20%3E%20(property)%20thresholds%20%3E%20(property)%20period_seconds">Link to this property</a>

requests: Optional\[int]

The estimated number of requests covered by these calculations.

<a href="#(resource)%20api_gateway.user_schemas.operations%20%3E%20(model)%20operation_list_response%20%3E%20(schema)%20%3E%20(variant)%200%20%3E%20(property)%20features%20%3E%20(variant)%200%20%3E%20(property)%20thresholds%20%3E%20(property)%20requests">Link to this property</a>

suggested\_threshold: Optional\[int]

The suggested threshold in requests done by the same auth\_id or period\_seconds.

<a href="#(resource)%20api_gateway.user_schemas.operations%20%3E%20(model)%20operation_list_response%20%3E%20(schema)%20%3E%20(variant)%200%20%3E%20(property)%20features%20%3E%20(variant)%200%20%3E%20(property)%20thresholds%20%3E%20(property)%20suggested_threshold">Link to this property</a>

</details>

<a href="#(resource)%20api_gateway.user_schemas.operations%20%3E%20(model)%20operation_list_response%20%3E%20(schema)%20%3E%20(variant)%200%20%3E%20(property)%20features%20%3E%20(variant)%200%20%3E%20(property)%20thresholds">Link to this property</a>

</details>

<a href="#(resource)%20api_gateway.user_schemas.operations%20%3E%20(model)%20operation_list_response%20%3E%20(schema)%20%3E%20(variant)%200%20%3E%20(property)%20features%20%3E%20(variant)%200">Link to this property</a>

<details>

<summary>

class APIShieldOperationFeaturesAPIShieldOperationFeatureParameterSchemas: …

</summary>

<details>

<summary>

parameter\_schemas: APIShieldOperationFeaturesAPIShieldOperationFeatureParameterSchemasParameterSchemas

</summary>

last\_updated: Optional\[datetime]

formatdate-time

<a href="#(resource)%20api_gateway.user_schemas.operations%20%3E%20(model)%20operation_list_response%20%3E%20(schema)%20%3E%20(variant)%200%20%3E%20(property)%20features%20%3E%20(variant)%201%20%3E%20(property)%20parameter_schemas%20%3E%20(property)%20last_updated">Link to this property</a>

<details>

<summary>

parameter\_schemas: Optional\[APIShieldOperationFeaturesAPIShieldOperationFeatureParameterSchemasParameterSchemasParameterSchemas]

An operation schema object containing a response.

</summary>

parameters: Optional\[List\[object]]

An array containing the learned parameter schemas.

<a href="#(resource)%20api_gateway.user_schemas.operations%20%3E%20(model)%20operation_list_response%20%3E%20(schema)%20%3E%20(variant)%200%20%3E%20(property)%20features%20%3E%20(variant)%201%20%3E%20(property)%20parameter_schemas%20%3E%20(property)%20parameter_schemas%20%3E%20(property)%20parameters">Link to this property</a>

responses: Optional\[object]

An empty response object. This field is required to yield a valid operation schema.

<a href="#(resource)%20api_gateway.user_schemas.operations%20%3E%20(model)%20operation_list_response%20%3E%20(schema)%20%3E%20(variant)%200%20%3E%20(property)%20features%20%3E%20(variant)%201%20%3E%20(property)%20parameter_schemas%20%3E%20(property)%20parameter_schemas%20%3E%20(property)%20responses">Link to this property</a>

</details>

<a href="#(resource)%20api_gateway.user_schemas.operations%20%3E%20(model)%20operation_list_response%20%3E%20(schema)%20%3E%20(variant)%200%20%3E%20(property)%20features%20%3E%20(variant)%201%20%3E%20(property)%20parameter_schemas%20%3E%20(property)%20parameter_schemas">Link to this property</a>

</details>

<a href="#(resource)%20api_gateway.user_schemas.operations%20%3E%20(model)%20operation_list_response%20%3E%20(schema)%20%3E%20(variant)%200%20%3E%20(property)%20features%20%3E%20(variant)%201%20%3E%20(property)%20parameter_schemas">Link to this property</a>

</details>

<a href="#(resource)%20api_gateway.user_schemas.operations%20%3E%20(model)%20operation_list_response%20%3E%20(schema)%20%3E%20(variant)%200%20%3E%20(property)%20features%20%3E%20(variant)%201">Link to this property</a>

<details>

<summary>

class APIShieldOperationFeaturesAPIShieldOperationFeatureAPIRouting: …

</summary>

<details>

<summary>

api\_routing: Optional\[APIShieldOperationFeaturesAPIShieldOperationFeatureAPIRoutingAPIRouting]

API Routing settings on endpoint.

</summary>

last\_updated: Optional\[datetime]

formatdate-time

<a href="#(resource)%20api_gateway.user_schemas.operations%20%3E%20(model)%20operation_list_response%20%3E%20(schema)%20%3E%20(variant)%200%20%3E%20(property)%20features%20%3E%20(variant)%202%20%3E%20(property)%20api_routing%20%3E%20(property)%20last_updated">Link to this property</a>

route: Optional\[str]

Target route.

<a href="#(resource)%20api_gateway.user_schemas.operations%20%3E%20(model)%20operation_list_response%20%3E%20(schema)%20%3E%20(variant)%200%20%3E%20(property)%20features%20%3E%20(variant)%202%20%3E%20(property)%20api_routing%20%3E%20(property)%20route">Link to this property</a>

</details>

<a href="#(resource)%20api_gateway.user_schemas.operations%20%3E%20(model)%20operation_list_response%20%3E%20(schema)%20%3E%20(variant)%200%20%3E%20(property)%20features%20%3E%20(variant)%202%20%3E%20(property)%20api_routing">Link to this property</a>

</details>

<a href="#(resource)%20api_gateway.user_schemas.operations%20%3E%20(model)%20operation_list_response%20%3E%20(schema)%20%3E%20(variant)%200%20%3E%20(property)%20features%20%3E%20(variant)%202">Link to this property</a>

<details>

<summary>

class APIShieldOperationFeaturesAPIShieldOperationFeatureConfidenceIntervals: …

</summary>

<details>

<summary>

confidence\_intervals: Optional\[APIShieldOperationFeaturesAPIShieldOperationFeatureConfidenceIntervalsConfidenceIntervals]

</summary>

last\_updated: Optional\[datetime]

formatdate-time

<a href="#(resource)%20api_gateway.user_schemas.operations%20%3E%20(model)%20operation_list_response%20%3E%20(schema)%20%3E%20(variant)%200%20%3E%20(property)%20features%20%3E%20(variant)%203%20%3E%20(property)%20confidence_intervals%20%3E%20(property)%20last_updated">Link to this property</a>

<details>

<summary>

suggested\_threshold: Optional\[APIShieldOperationFeaturesAPIShieldOperationFeatureConfidenceIntervalsConfidenceIntervalsSuggestedThreshold]

</summary>

<details>

<summary>

confidence\_intervals: Optional\[APIShieldOperationFeaturesAPIShieldOperationFeatureConfidenceIntervalsConfidenceIntervalsSuggestedThresholdConfidenceIntervals]

</summary>

<details>

<summary>

p90: Optional\[APIShieldOperationFeaturesAPIShieldOperationFeatureConfidenceIntervalsConfidenceIntervalsSuggestedThresholdConfidenceIntervalsP90]

Upper and lower bound for percentile estimate

</summary>

lower: Optional\[float]

Lower bound for percentile estimate

<a href="#(resource)%20api_gateway.user_schemas.operations%20%3E%20(model)%20operation_list_response%20%3E%20(schema)%20%3E%20(variant)%200%20%3E%20(property)%20features%20%3E%20(variant)%203%20%3E%20(property)%20confidence_intervals%20%3E%20(property)%20suggested_threshold%20%3E%20(property)%20confidence_intervals%20%3E%20(property)%20p90%20%3E%20(property)%20lower">Link to this property</a>

upper: Optional\[float]

Upper bound for percentile estimate

<a href="#(resource)%20api_gateway.user_schemas.operations%20%3E%20(model)%20operation_list_response%20%3E%20(schema)%20%3E%20(variant)%200%20%3E%20(property)%20features%20%3E%20(variant)%203%20%3E%20(property)%20confidence_intervals%20%3E%20(property)%20suggested_threshold%20%3E%20(property)%20confidence_intervals%20%3E%20(property)%20p90%20%3E%20(property)%20upper">Link to this property</a>

</details>

<a href="#(resource)%20api_gateway.user_schemas.operations%20%3E%20(model)%20operation_list_response%20%3E%20(schema)%20%3E%20(variant)%200%20%3E%20(property)%20features%20%3E%20(variant)%203%20%3E%20(property)%20confidence_intervals%20%3E%20(property)%20suggested_threshold%20%3E%20(property)%20confidence_intervals%20%3E%20(property)%20p90">Link to this property</a>

<details>

<summary>

p95: Optional\[APIShieldOperationFeaturesAPIShieldOperationFeatureConfidenceIntervalsConfidenceIntervalsSuggestedThresholdConfidenceIntervalsP95]

Upper and lower bound for percentile estimate

</summary>

lower: Optional\[float]

Lower bound for percentile estimate

<a href="#(resource)%20api_gateway.user_schemas.operations%20%3E%20(model)%20operation_list_response%20%3E%20(schema)%20%3E%20(variant)%200%20%3E%20(property)%20features%20%3E%20(variant)%203%20%3E%20(property)%20confidence_intervals%20%3E%20(property)%20suggested_threshold%20%3E%20(property)%20confidence_intervals%20%3E%20(property)%20p95%20%3E%20(property)%20lower">Link to this property</a>

upper: Optional\[float]

Upper bound for percentile estimate

<a href="#(resource)%20api_gateway.user_schemas.operations%20%3E%20(model)%20operation_list_response%20%3E%20(schema)%20%3E%20(variant)%200%20%3E%20(property)%20features%20%3E%20(variant)%203%20%3E%20(property)%20confidence_intervals%20%3E%20(property)%20suggested_threshold%20%3E%20(property)%20confidence_intervals%20%3E%20(property)%20p95%20%3E%20(property)%20upper">Link to this property</a>

</details>

<a href="#(resource)%20api_gateway.user_schemas.operations%20%3E%20(model)%20operation_list_response%20%3E%20(schema)%20%3E%20(variant)%200%20%3E%20(property)%20features%20%3E%20(variant)%203%20%3E%20(property)%20confidence_intervals%20%3E%20(property)%20suggested_threshold%20%3E%20(property)%20confidence_intervals%20%3E%20(property)%20p95">Link to this property</a>

<details>

<summary>

p99: Optional\[APIShieldOperationFeaturesAPIShieldOperationFeatureConfidenceIntervalsConfidenceIntervalsSuggestedThresholdConfidenceIntervalsP99]

Upper and lower bound for percentile estimate

</summary>

lower: Optional\[float]

Lower bound for percentile estimate

<a href="#(resource)%20api_gateway.user_schemas.operations%20%3E%20(model)%20operation_list_response%20%3E%20(schema)%20%3E%20(variant)%200%20%3E%20(property)%20features%20%3E%20(variant)%203%20%3E%20(property)%20confidence_intervals%20%3E%20(property)%20suggested_threshold%20%3E%20(property)%20confidence_intervals%20%3E%20(property)%20p99%20%3E%20(property)%20lower">Link to this property</a>

upper: Optional\[float]

Upper bound for percentile estimate

<a href="#(resource)%20api_gateway.user_schemas.operations%20%3E%20(model)%20operation_list_response%20%3E%20(schema)%20%3E%20(variant)%200%20%3E%20(property)%20features%20%3E%20(variant)%203%20%3E%20(property)%20confidence_intervals%20%3E%20(property)%20suggested_threshold%20%3E%20(property)%20confidence_intervals%20%3E%20(property)%20p99%20%3E%20(property)%20upper">Link to this property</a>

</details>

<a href="#(resource)%20api_gateway.user_schemas.operations%20%3E%20(model)%20operation_list_response%20%3E%20(schema)%20%3E%20(variant)%200%20%3E%20(property)%20features%20%3E%20(variant)%203%20%3E%20(property)%20confidence_intervals%20%3E%20(property)%20suggested_threshold%20%3E%20(property)%20confidence_intervals%20%3E%20(property)%20p99">Link to this property</a>

</details>

<a href="#(resource)%20api_gateway.user_schemas.operations%20%3E%20(model)%20operation_list_response%20%3E%20(schema)%20%3E%20(variant)%200%20%3E%20(property)%20features%20%3E%20(variant)%203%20%3E%20(property)%20confidence_intervals%20%3E%20(property)%20suggested_threshold%20%3E%20(property)%20confidence_intervals">Link to this property</a>

mean: Optional\[float]

Suggested threshold.

<a href="#(resource)%20api_gateway.user_schemas.operations%20%3E%20(model)%20operation_list_response%20%3E%20(schema)%20%3E%20(variant)%200%20%3E%20(property)%20features%20%3E%20(variant)%203%20%3E%20(property)%20confidence_intervals%20%3E%20(property)%20suggested_threshold%20%3E%20(property)%20mean">Link to this property</a>

</details>

<a href="#(resource)%20api_gateway.user_schemas.operations%20%3E%20(model)%20operation_list_response%20%3E%20(schema)%20%3E%20(variant)%200%20%3E%20(property)%20features%20%3E%20(variant)%203%20%3E%20(property)%20confidence_intervals%20%3E%20(property)%20suggested_threshold">Link to this property</a>

</details>

<a href="#(resource)%20api_gateway.user_schemas.operations%20%3E%20(model)%20operation_list_response%20%3E%20(schema)%20%3E%20(variant)%200%20%3E%20(property)%20features%20%3E%20(variant)%203%20%3E%20(property)%20confidence_intervals">Link to this property</a>

</details>

<a href="#(resource)%20api_gateway.user_schemas.operations%20%3E%20(model)%20operation_list_response%20%3E%20(schema)%20%3E%20(variant)%200%20%3E%20(property)%20features%20%3E%20(variant)%203">Link to this property</a>

<details>

<summary>

class APIShieldOperationFeaturesAPIShieldOperationFeatureSchemaInfo: …

</summary>

<details>

<summary>

schema\_info: Optional\[APIShieldOperationFeaturesAPIShieldOperationFeatureSchemaInfoSchemaInfo]

</summary>

<details>

<summary>

active\_schema: Optional\[APIShieldOperationFeaturesAPIShieldOperationFeatureSchemaInfoSchemaInfoActiveSchema]

Schema active on endpoint.

</summary>

id: Optional\[str]

UUID.

maxLength36

minLength36

<a href="#(resource)%20api_gateway.user_schemas.operations%20%3E%20(model)%20operation_list_response%20%3E%20(schema)%20%3E%20(variant)%200%20%3E%20(property)%20features%20%3E%20(variant)%204%20%3E%20(property)%20schema_info%20%3E%20(property)%20active_schema%20%3E%20(property)%20id">Link to this property</a>

created\_at: Optional\[datetime]

formatdate-time

<a href="#(resource)%20api_gateway.user_schemas.operations%20%3E%20(model)%20operation_list_response%20%3E%20(schema)%20%3E%20(variant)%200%20%3E%20(property)%20features%20%3E%20(variant)%204%20%3E%20(property)%20schema_info%20%3E%20(property)%20active_schema%20%3E%20(property)%20created_at">Link to this property</a>

name: Optional\[str]

Schema file name.

<a href="#(resource)%20api_gateway.user_schemas.operations%20%3E%20(model)%20operation_list_response%20%3E%20(schema)%20%3E%20(variant)%200%20%3E%20(property)%20features%20%3E%20(variant)%204%20%3E%20(property)%20schema_info%20%3E%20(property)%20active_schema%20%3E%20(property)%20name">Link to this property</a>

</details>

<a href="#(resource)%20api_gateway.user_schemas.operations%20%3E%20(model)%20operation_list_response%20%3E%20(schema)%20%3E%20(variant)%200%20%3E%20(property)%20features%20%3E%20(variant)%204%20%3E%20(property)%20schema_info%20%3E%20(property)%20active_schema">Link to this property</a>

<details>

<summary>

mitigation\_action: Optional\[Literal\["none", "log", "block"]]

Action taken on requests failing validation.

</summary>

One of the following:

"none"

<a href="#(resource)%20api_gateway.user_schemas.operations%20%3E%20(model)%20operation_list_response%20%3E%20(schema)%20%3E%20(variant)%200%20%3E%20(property)%20features%20%3E%20(variant)%204%20%3E%20(property)%20schema_info%20%3E%20(property)%20mitigation_action%20%3E%20(member)%200">Link to this property</a>

"log"

<a href="#(resource)%20api_gateway.user_schemas.operations%20%3E%20(model)%20operation_list_response%20%3E%20(schema)%20%3E%20(variant)%200%20%3E%20(property)%20features%20%3E%20(variant)%204%20%3E%20(property)%20schema_info%20%3E%20(property)%20mitigation_action%20%3E%20(member)%201">Link to this property</a>

"block"

<a href="#(resource)%20api_gateway.user_schemas.operations%20%3E%20(model)%20operation_list_response%20%3E%20(schema)%20%3E%20(variant)%200%20%3E%20(property)%20features%20%3E%20(variant)%204%20%3E%20(property)%20schema_info%20%3E%20(property)%20mitigation_action%20%3E%20(member)%202">Link to this property</a>

</details>

<a href="#(resource)%20api_gateway.user_schemas.operations%20%3E%20(model)%20operation_list_response%20%3E%20(schema)%20%3E%20(variant)%200%20%3E%20(property)%20features%20%3E%20(variant)%204%20%3E%20(property)%20schema_info%20%3E%20(property)%20mitigation_action">Link to this property</a>

</details>

<a href="#(resource)%20api_gateway.user_schemas.operations%20%3E%20(model)%20operation_list_response%20%3E%20(schema)%20%3E%20(variant)%200%20%3E%20(property)%20features%20%3E%20(variant)%204%20%3E%20(property)%20schema_info">Link to this property</a>

</details>

<a href="#(resource)%20api_gateway.user_schemas.operations%20%3E%20(model)%20operation_list_response%20%3E%20(schema)%20%3E%20(variant)%200%20%3E%20(property)%20features%20%3E%20(variant)%204">Link to this property</a>

</details>

<a href="#(resource)%20api_gateway.user_schemas.operations%20%3E%20(model)%20operation_list_response%20%3E%20(schema)%20%3E%20(variant)%200%20%3E%20(property)%20features">Link to this property</a>

</details>

<a href="#(resource)%20api_gateway.user_schemas.operations%20%3E%20(model)%20operation_list_response%20%3E%20(schema)%20%3E%20(variant)%200">Link to this property</a>

<details>

<summary>

class APIShieldBasicOperation: …

</summary>

endpoint: str

The endpoint which can contain path parameter templates in curly braces, each will be replaced from left to right with {varN}, starting with {var1}, during insertion. This will further be Cloudflare-normalized upon insertion. See: <a href="https://developers.cloudflare.com/rules/normalization/how-it-works/">https://developers.cloudflare.com/rules/normalization/how-it-works/</a>.

formaturi-template

maxLength4096

<a href="#(resource)%20api_gateway.user_schemas.operations%20%3E%20(model)%20operation_list_response%20%3E%20(schema)%20%3E%20(variant)%201%20%3E%20(property)%20endpoint">Link to this property</a>

host: str

RFC3986-compliant host.

formathostname

maxLength255

<a href="#(resource)%20api_gateway.user_schemas.operations%20%3E%20(model)%20operation_list_response%20%3E%20(schema)%20%3E%20(variant)%201%20%3E%20(property)%20host">Link to this property</a>

<details>

<summary>

method: Literal\["GET", "POST", "HEAD", 6 more]

The HTTP method used to access the endpoint.

</summary>

One of the following:

"GET"

<a href="#(resource)%20api_gateway.user_schemas.operations%20%3E%20(model)%20operation_list_response%20%3E%20(schema)%20%3E%20(variant)%201%20%3E%20(property)%20method%20%3E%20(member)%200">Link to this property</a>

"POST"

<a href="#(resource)%20api_gateway.user_schemas.operations%20%3E%20(model)%20operation_list_response%20%3E%20(schema)%20%3E%20(variant)%201%20%3E%20(property)%20method%20%3E%20(member)%201">Link to this property</a>

"HEAD"

<a href="#(resource)%20api_gateway.user_schemas.operations%20%3E%20(model)%20operation_list_response%20%3E%20(schema)%20%3E%20(variant)%201%20%3E%20(property)%20method%20%3E%20(member)%202">Link to this property</a>

"OPTIONS"

<a href="#(resource)%20api_gateway.user_schemas.operations%20%3E%20(model)%20operation_list_response%20%3E%20(schema)%20%3E%20(variant)%201%20%3E%20(property)%20method%20%3E%20(member)%203">Link to this property</a>

"PUT"

<a href="#(resource)%20api_gateway.user_schemas.operations%20%3E%20(model)%20operation_list_response%20%3E%20(schema)%20%3E%20(variant)%201%20%3E%20(property)%20method%20%3E%20(member)%204">Link to this property</a>

"DELETE"

<a href="#(resource)%20api_gateway.user_schemas.operations%20%3E%20(model)%20operation_list_response%20%3E%20(schema)%20%3E%20(variant)%201%20%3E%20(property)%20method%20%3E%20(member)%205">Link to this property</a>

"CONNECT"

<a href="#(resource)%20api_gateway.user_schemas.operations%20%3E%20(model)%20operation_list_response%20%3E%20(schema)%20%3E%20(variant)%201%20%3E%20(property)%20method%20%3E%20(member)%206">Link to this property</a>

"PATCH"

<a href="#(resource)%20api_gateway.user_schemas.operations%20%3E%20(model)%20operation_list_response%20%3E%20(schema)%20%3E%20(variant)%201%20%3E%20(property)%20method%20%3E%20(member)%207">Link to this property</a>

"TRACE"

<a href="#(resource)%20api_gateway.user_schemas.operations%20%3E%20(model)%20operation_list_response%20%3E%20(schema)%20%3E%20(variant)%201%20%3E%20(property)%20method%20%3E%20(member)%208">Link to this property</a>

</details>

<a href="#(resource)%20api_gateway.user_schemas.operations%20%3E%20(model)%20operation_list_response%20%3E%20(schema)%20%3E%20(variant)%201%20%3E%20(property)%20method">Link to this property</a>

</details>

<a href="#(resource)%20api_gateway.user_schemas.operations%20%3E%20(model)%20operation_list_response%20%3E%20(schema)%20%3E%20(variant)%201">Link to this property</a>

</details>

[Link to this property](<#(resource)%20api_gateway.user_schemas.operations%20%3E%20(model)%20operation_list_response%20%3E%20(schema)>)

#### User SchemasHosts

##### [Retrieve schema hosts in a zone](https://developers.cloudflare.com/api/python/resources/api_gateway/subresources/user_schemas/subresources/hosts/methods/list)

Deprecated

api\_gateway.user\_schemas.hosts.list(HostListParams\*\*kwargs) -> SyncV4PagePaginationArray\[[HostListResponse](<https://developers.cloudflare.com/api/python/resources/api_gateway#(resource)%20api_gateway.user_schemas.hosts%20%3E%20(model)%20host_list_response%20%3E%20(schema)>)]

GET/zones/{zone\_id}/api\_gateway/user\_schemas/hosts

##### ModelsExpand Collapse

<details>

<summary>

class HostListResponse: …

</summary>

created\_at: datetime

formatdate-time

<a href="#(resource)%20api_gateway.user_schemas.hosts%20%3E%20(model)%20host_list_response%20%3E%20(schema)%20%3E%20(property)%20created_at">Link to this property</a>

hosts: List\[str]

Hosts serving the schema, e.g zone.host.com

<a href="#(resource)%20api_gateway.user_schemas.hosts%20%3E%20(model)%20host_list_response%20%3E%20(schema)%20%3E%20(property)%20hosts">Link to this property</a>

name: str

Name of the schema

<a href="#(resource)%20api_gateway.user_schemas.hosts%20%3E%20(model)%20host_list_response%20%3E%20(schema)%20%3E%20(property)%20name">Link to this property</a>

schema\_id: str

UUID.

maxLength36

minLength36

<a href="#(resource)%20api_gateway.user_schemas.hosts%20%3E%20(model)%20host_list_response%20%3E%20(schema)%20%3E%20(property)%20schema_id">Link to this property</a>

</details>

[Link to this property](<#(resource)%20api_gateway.user_schemas.hosts%20%3E%20(model)%20host_list_response%20%3E%20(schema)>)